<template>
  <div class="signup-container">
    <authenticator :auth-config="authConfig" @onError="setError" />
  </div>
</template>

<script>
import { Authenticator } from '@/components/Authenticator'
import { mapActions } from 'vuex'
import { ehrApi } from '@/api'
export default {
  components: {
    Authenticator
  },
  data () {
    return {
      isLoginError: false,
      erroMessage: null,
      authConfig: {
        signInConfig: {
          isSignUpDisplayed: true,
          isSNSSignUpDisplayed: false
        }
      }
    }
  },
  layout: 'SessionLayout',
  created () {
    this.erroMessage = null
    this.isLoginError = false
    this.$bus.$on('authState', (info) => {
      if (info === 'signedIn') {
        this.loginSuccess()
      } else {
        console.log('authState:', info)
      }
    })
  },
  methods: {
    ...mapActions('auth', ['saveInfo']),
    ...mapActions('permission', ['generateAsyncRoutes']),
    async loginSuccess () {
      try {
        this.erroMessage = null
        this.isLoginError = false
        const userInfo = await ehrApi.user.me()
        const roles = userInfo.roles
        const groups = [roles[0].name]
        await this.generateAsyncRoutes({ groups })
        this.$router.addRoutes(this.$store.getters['permission/addRouters'])
        await this.saveInfo(userInfo)
        this.$router.push({ name: 'home' })
      } catch (error) {
        this.notiError(error)
      }
    },
    notiError (err) {
      this.$notification.error({
        message: 'Lỗi',
        description: err,
        duration: 4
      })
    },
    setError (e) {
      this.isLoginError = true
      this.erroMessage = e.message || 'エラーが起こりました。後でやり直してください'
    }
  }
}
</script>

<style lang="less">
.user-layout-container {
  width: 100%;
  min-height: 100%;
  background-repeat: no-repeat;
  background-size: 50%;
  padding: 110px 0 144px;
  position: relative;
}
.signup-container {
  max-width: 760px;
  margin: auto;
  .ant-layout-content {
    margin-bottom: 60px;
  }
  .ant-layout-header {
    background: transparent;
    box-shadow: none;
    display: flex;
    align-items: center;
    margin: 24px auto;
    &.session-header {
      .logo {
        height: 44px;
        vertical-align: top;
        margin-right: 16px;
        border-style: none;
      }

      .title {
        font-size: 33px;
        font-weight: 600;
        position: relative;
        top: 2px;
      }
    }
  }

  .card {
    margin-bottom: 24px;
  }
  .popover-wrapper {
    /deep/ .antd-pro-pages-forms-style-errorPopover .ant-popover-inner-content {
      min-width: 256px;
      max-height: 290px;
      padding: 0;
      overflow: auto;
    }
  }
  .antd-pro-pages-forms-style-errorIcon {
    user-select: none;
    margin-right: 24px;
    color: #f5222d;
    cursor: pointer;
    i {
      margin-right: 4px;
    }
  }
  .antd-pro-pages-forms-style-errorListItem {
    padding: 8px 16px;
    list-style: none;
    border-bottom: 1px solid #e8e8e8;
    cursor: pointer;
    transition: all 0.3s;

    &:hover {
      background: #e6f7ff;
    }
    .antd-pro-pages-forms-style-errorIcon {
      float: left;
      margin-top: 4px;
      margin-right: 12px;
      padding-bottom: 22px;
      color: #f5222d;
    }
    .antd-pro-pages-forms-style-errorField {
      margin-top: 2px;
      color: rgba(0, 0, 0, 0.45);
      font-size: 12px;
    }
  }
}
</style>
